<?php
/*
Plugin Name: Lightbox 2.02 Plugin
Plugin URI: http://www.m3nt0r.de/blog/lightbox-wordpress-plugin/
Feed URI:
Description: Plugin that turns linked images into neat Javascript overlays popups, which is much nicer instead of just linking to fullsize images. This plugin uses the cool Lightbox javascript by <a href="http://www.huddletogether.com/projects/lightbox2/">Lokesh Dhakar</a>, which has been transformed to a Wordpress plugin by me, inspired by Frank from <a href="http://2d-sign.info/">2d-sign</a>. Revised and modified by <a href="http://stevewinton.com/">Steve Winton</a>, proceed with caution! -> <strong>beta</strong>
Version: 0.6.4 beta
Author: Kjell Bublitz
Author URI: http://www.m3nt0r.de/blog/
*/

define("IMAGE_EXTENSIONS",            'jpg|jpeg|png|gif|bmp|ico');   	// checking for extension, divided by pipes (no leading or trailing pipe!!)
define("DISABLE_LIGHTBOX_ON_POST",    '##NOLIGHTBOX##');   				// disables the lightbox converter on the whole post/page
define("DISABLE_LIGHTBOX_ON_IMAGE",   'nolb');             				// to be used in the title-tag, disables converter on image containing.
define("LIGHTBOX_DEBUG",              '##LB_DEBUG##');     				// if you put this in a post a debug output will be displayed.
define("LIGHTBOX_SPEED", 			  7);								// controls the speed of the image resizing (1=slowest and 10=fastest)
define("LIGHTBOX_BORDER", 			  10);								// if you adjust the padding in the CSS, you will need to update this variable

/*******************************************************************
*	DON'T EDIT THIS FILE UNLESS YOU KNOW WHAT YOU ARE DOING
*******************************************************************/


// function for header include
// -------------------------------------------------------------------------------------------

     function lightbox_header()
     {
		// !!! SW Begin
		// Much simpler doing it this way...
		$lightbox_pluginpath = get_settings('siteurl').'/wp-content/plugins/lightbox-plugin/';
		// !!! SW End

		// prepare headerinclude and print
		$lightboxHead = "\n\t<!-- Lightbox Plugin -->\n\t<link rel=\"stylesheet\" href=\"".$lightbox_pluginpath."lightbox2.css\" type=\"text/css\" media=\"screen\" />\n";
		$lightboxHead.= "\t<script type=\"text/javascript\">\n\t\tvar fileLoadingImage = '".$lightbox_pluginpath."images/loading.gif';\n\t\tvar fileBottomNavCloseImage = '".$lightbox_pluginpath."images/closelabel.gif';\n\t\tvar resizeSpeed = ".LIGHTBOX_SPEED.";\n\t\tvar borderSize = ".LIGHTBOX_BORDER.";\n\t</script>\n";
		$lightboxHead.= "\t<script type=\"text/javascript\" src=\"".$lightbox_pluginpath."js/prototype.js\"></script>\n";
		$lightboxHead.= "\t<script type=\"text/javascript\" src=\"".$lightbox_pluginpath."js/effects.js\"></script>\n";
		$lightboxHead.= "\t<script type=\"text/javascript\" src=\"".$lightbox_pluginpath."lightbox2.js\"></script>\n\t<!-- /Lightbox Plugin -->\n";
		
		print($lightboxHead);
     }

// PHP4 compat function
// -------------------------------------------------------------------------------------------

	if(!function_exists("stripos"))
	{
		function stripos($str, $needle)
		{
			return strpos(strtolower($str),strtolower($needle));
		}
	}


// the actual link convert function
// -------------------------------------------------------------------------------------------

	function lightbox_converter($content)
	{
		// check if lightbox is not disabled
		if(stripos($content, DISABLE_LIGHTBOX_ON_POST) === false)
		{			
			// get all links
            preg_match_all('/\<a(.*?)href="(.*?)"(.*?)\>/i', $content, $found);

			// debug output
			if (stripos($content, LIGHTBOX_DEBUG) !== false)
			{
				$noimgcount = 0;
				$debug = '<div style="text-align:left;border:1px solid red;padding:5px"><strong>Lightbox Debug</strong><br />';

				if(preg_match('/.('.IMAGE_EXTENSIONS.')/i', $content))
                {					                	
					$debug.= '<ul style="padding:0;margin:0;">';
					foreach($found[0] as $link) 
					{
						if(preg_match('/.('.IMAGE_EXTENSIONS.')/i', $link)) 
						{
							$debug.= '<li><small>'.str_replace('<', '&lt;', str_replace('>', '&gt;', $link))."</small></li>";
						} 
						else 
						{
							$noimgcount++;
						}
					}
					$debug.= '</ul>';
					$debug.= $noimgcount.' links weren\'t imagelinks.';
				}
				else
				{
					$debug.= 'No images found.';
				}
				$debug.= '</div>';
				$content = str_replace(LIGHTBOX_DEBUG, $debug, $content);
			}

			// run conversion on them			
			foreach ($found[0] as $link)
			{
				// !!! SW Begin
				// Examine the href attribute...
				if (preg_match('/href[\s]?=[\s\"\'\`]+.*('.IMAGE_EXTENSIONS.')[\"\'\`]/i', $link))					
				// !!! SW End
				{
					// check for series tag
					preg_match('/"{(.*)}/i', $link, $title); 
										
					if (!empty($title[1])) // series
					{
						if ($title[1] != DISABLE_LIGHTBOX_ON_IMAGE) // not disabled
						{
							$nlink = str_replace($title[0].' ', '"', $link); // remove series tag
							$nlink = str_replace('>',' rel="lightbox['.$title[1].']">',$nlink);  // add series rel-tag
						}
						else // no lightbox wanted, remove tag
						{
							$nlink = str_replace($title[0].' ', '"', $link);
						}
					}
					else  // simple image link, no series
					{
						$nlink = str_replace('>', ' rel="lightbox">', $link);  // add default rel-tag
					}

					// replace the old link with the new one
					$content = str_replace($link, $nlink, $content);
				}
			}
		}
		else // remove lightbox disable string
		{
			$content = str_replace(DISABLE_LIGHTBOX_ON_POST, "", $content);
		}

		return $content;
	}

// output to the <head> section of the page
add_action('wp_head', 'lightbox_header');

// run the lightbox converter upon the content
add_filter('the_content', 'lightbox_converter', 2);

?>